<template>
  <block :title="title" :on-resize='initChart'>
    <template v-slot:main>
      <div class="filters">
        <slot name="filters"></slot>
      </div>
      <div class="grid-chart" :id="id">

      </div>
    </template>
  </block>
</template>

<script>

import Block from '@/components/Block/block.vue';
import { copyObj, uuid } from '@/utils';
import * as echarts from 'echarts';
import SwitchTag from '../../SwitchTag/index.vue';

const basicSerie = {
  type: 'bar',
  label: {
    show: true,
  },
  stack: '总量',
  data: [],
};
const opts = {
  tooltip: {
    trigger: 'axis',
    axisPointer: {
      type: 'shadow',
    },
  },
  legend: {
    data: [],
  },
  grid: {
    left: '3%',
    right: '4%',
    bottom: '3%',
    containLabel: true,
  },
  xAxis: {
    type: 'category',
    boundaryGap: true,
    data: [],
    axisTick: {
      alignWithLabel: true,
    },
  },
  yAxis: {
    type: 'value',
    minInterval: 1,
  },
  series: [],
};
export default {
  components: {
    Block,
    SwitchTag,
  },
  props: {
    title: {
      default: '标题',
      type: String,
    },
    optCfg: {
      type: Object,
      default: () => {
        return {};
      },
    },
  },
  watch: {
    optCfg: {
      handler(val) {
        this.initChart();
      },
      deep: true,
    },
  },
  data() {
    return {
      id: uuid(),
      refCharts: null,
    };
  },
  mounted() {
    this.$nextTick(this.initChart);
  },
  created() {
  },
  methods: {
    initChart() {
      this.refCharts && this.refCharts.clear();
      const chartDom = document.getElementById(this.id);
      this.refCharts = echarts.init(chartDom);
      const option = copyObj(opts);
      const legend = [];
      this.optCfg.series.forEach((item, index) => {
        const serie = copyObj(basicSerie);
        Object.assign(serie, item);
        option.series.push(serie);
        legend.push(item.name);
      });
      option.legend.data = legend;
      option.xAxis = this.optCfg.xAxis;
      option && this.refCharts && this.refCharts.setOption(option);
      this.refCharts.resize();
    },
  },
};
</script>
<style src="./index.scss" lang="scss" />
